#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "system.h"

#define MAX_NUMBER_OF_BINS 500

void Sample(int Choise,double r2,double W)
{
  int i;
  static double Normalize,Sum[MAX_NUMBER_OF_BINS],dx;
  FILE *FilePtr;

  switch(Choise)
  {
    case INITIALIZE:
      dx=(MAX_NUMBER_OF_BINS-1.0)/MAX_CHAIN_LENGTH;
      Normalize=0.0;
      for(i=0;i<MAX_NUMBER_OF_BINS;i++)
        Sum[i]=0.0;
      break;
    case SAMPLE:
      i=(int)(r2*dx);
      if(i<MAX_NUMBER_OF_BINS)
        Sum[i]+=W*r2;
      Normalize+=W;
      break;
    case WRITE_RESULTS:
      FilePtr=fopen("results.dat","w");
      for(i=0;i<MAX_NUMBER_OF_BINS;i++)
        if(Sum[i]>0.5)
          fprintf(FilePtr,"%f %f\n",i/dx,Sum[i]/Normalize);
      fclose(FilePtr);
      break;
  }
}

